package cn.wzpmc.hny.commands.lobby;

import cn.wzpmc.hny.commands.lobby.sub.CancelVoteCommand;
import cn.wzpmc.hny.commands.lobby.provider.GameSuggestionProvider;
import cn.wzpmc.hny.commands.lobby.sub.debug.DoneCommand;
import cn.wzpmc.hny.commands.lobby.sub.debug.ResetCommand;
import cn.wzpmc.hny.commands.lobby.sub.debug.ShowCommand;
import cn.wzpmc.hny.commands.lobby.sub.VoteCommand;
import cn.wzpmc.hny.commands.lobby.sub.debug.wind.CreateWindCommand;
import cn.wzpmc.hny.commands.lobby.sub.debug.wind.RemoveWindCommand;
import cn.wzpmc.hny.utils.Wind;
import com.mojang.brigadier.arguments.DoubleArgumentType;
import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.builder.RequiredArgumentBuilder;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.permissions.ServerOperator;
import org.mmga.utils.interfaces.MmgaCommand;

public class LobbyTestCommand implements MmgaCommand {
    @Override
    public LiteralArgumentBuilder<CommandSender> getCommandBuilder() {
        return LiteralArgumentBuilder.<CommandSender>literal("lt")
                .requires(e -> e instanceof Player).then(
                        LiteralArgumentBuilder.<CommandSender>literal("vote").then(
                                RequiredArgumentBuilder.<CommandSender, String>argument("stageName", StringArgumentType.word())
                                .suggests(new GameSuggestionProvider())
                                .executes(new VoteCommand())
                        ).then(LiteralArgumentBuilder.<CommandSender>literal("cancel").executes(new CancelVoteCommand()))
                ).then(LiteralArgumentBuilder.<CommandSender>literal("debug").requires(ServerOperator::isOp).then(
                        LiteralArgumentBuilder.<CommandSender>literal("show").then(
                                RequiredArgumentBuilder.<CommandSender, String>argument("stageName", StringArgumentType.word())
                                        .suggests(new GameSuggestionProvider())
                                        .executes(new ShowCommand())
                )).then(LiteralArgumentBuilder.<CommandSender>literal("reset").executes(new ResetCommand())
                ).then(LiteralArgumentBuilder.<CommandSender>literal("done").then(
                        RequiredArgumentBuilder.<CommandSender, String>argument("stageName", StringArgumentType.word())
                                .suggests(new GameSuggestionProvider())
                                .executes(new DoneCommand())
                )).then(LiteralArgumentBuilder.<CommandSender>literal("wind").then(
                        LiteralArgumentBuilder.<CommandSender>literal("create").then(
                                RequiredArgumentBuilder.<CommandSender, Double>argument("radius", DoubleArgumentType.doubleArg(0,10)).then(
                                        RequiredArgumentBuilder.<CommandSender, String>argument("name", StringArgumentType.word())
                                                .executes(new CreateWindCommand())))
                        ).then(LiteralArgumentBuilder.<CommandSender>literal("remove").then(
                                RequiredArgumentBuilder.<CommandSender, String>argument("name", StringArgumentType.word())
                                        .suggests(new Wind.WindSuggestion())
                                        .executes(new RemoveWindCommand())))
                )
        );
    }
}
