package cn.wzpmc.hny.events;

import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.pojo.BoxPosition;
import cn.wzpmc.hny.utils.Wind;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.title.Title;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.potion.PotionEffectType;

import java.util.HashMap;
import java.util.Map;

public class PlayerMove implements Listener {
    @EventHandler
    public void onPlayerMove(PlayerMoveEvent event){
        Player player = event.getPlayer();
        Location moveTo = event.getTo();
        for (Wind value : Wind.winds.values()) {
            if (value.isPointIn(moveTo)) {
                value.onPlayerIn(player);
            } else {
                if (player.getActivePotionEffects().stream().anyMatch(e -> e.getType().equals(PotionEffectType.LEVITATION))) {
                    player.removePotionEffect(PotionEffectType.LEVITATION);
                }
            }
        }
        World world = moveTo.getWorld();
        if (!world.getName().equals("game1")) {
            return;
        }
        if (moveTo.getBlockY() <= 144){
            return;
        }
        GameMode gameMode = player.getGameMode();
        if (gameMode.equals(GameMode.CREATIVE) || gameMode.equals(GameMode.SPECTATOR)) {
            return;
        }
        if (world.getBlockAt(moveTo.getBlockX(), moveTo.getBlockY() - 1, moveTo.getBlockZ()).isEmpty()){
            return;
        }
        for (Games value : Games.values()) {
            if (GameStageManager.getInstance().isUnlock(value)){
                continue;
            }
            BoxPosition boxPosition = value.getBoxPosition();
            if (boxPosition.isIn(moveTo)){
                player.showTitle(Title.title(Component.text("未解锁的区域").color(NamedTextColor.YELLOW), Component.text("前面的区域，以后再来探索吧").color(NamedTextColor.GREEN)));
                player.teleport(boxPosition.getNearestEdgePoint(moveTo));
                break;
            }
        }
    }
}
