package cn.wzpmc.hny.events;

import cn.wzpmc.hny.HappyNewLobby;
import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.utils.Wind;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.title.Title;
import org.bukkit.*;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

import java.time.Duration;
import java.util.Collection;

public class Tick extends BukkitRunnable {
    private final Server server;
    public Tick(){
        this.server = HappyNewLobby.getPlugin(HappyNewLobby.class).getServer();
    }
    @Override
    public void run() {
        GameStageManager instance = GameStageManager.getInstance();
        for (Games value : Games.values()) {
            if (instance.isNotStart(value) && instance.isUnlock(value)) {
                int size = instance.getVotePlayers(value).size();
                if (size > 0){
                    Collection<? extends Player> onlinePlayers = server.getOnlinePlayers();
                    int playersCount = onlinePlayers.size();
                    if (playersCount / 2f <= size){
                        for (Player onlinePlayer : onlinePlayers) {
                            onlinePlayer.showTitle(Title.title(
                                    Component.text("游戏开始！").color(NamedTextColor.GREEN),
                                    Component.empty(),
                                    Title.Times.times(Duration.ZERO, Duration.ofMillis(1000), Duration.ofMillis(500))
                            ));
                        }
                        instance.triggerGameStart(value);
                        continue;
                    }
                    for (Player onlinePlayer : onlinePlayers) {
                        onlinePlayer.showTitle(Title.title(
                                Component.text("有玩家发起了游戏投票(")
                                        .append(Component.text(size))
                                        .append(Component.text("/"))
                                        .append(Component.text(playersCount))
                                        .append(Component.text(")")),
                                Component.text("人数超过一半就会开始游戏"),
                                Title.Times.times(Duration.ZERO, Duration.ofMillis(500), Duration.ZERO)
                        ));
                    }
                }
            }
        }
        for (Wind value : Wind.winds.values()) {
            value.drawParticle();
        }
    }
}
